package getWay

import (
	"git.168cad.top/zhengqiuyun/rym-util/util"
	"github.com/gin-gonic/gin"
)

const (
	headerKeyToken     = "token"
	headerKeyPlatform  = "platform"
	headerKeyAppId     = "appId"
	headerKeyTimeStamp = "timeStamp"
	headerKeySign      = "sign"
)

const headerKeyClientSource = "clientSource"

func GetToken(c *gin.Context) string {
	return c.GetHeader(headerKeyToken)
}

func SetToken(v string, c *gin.Context) {
	c.Header(headerKeyToken, v)
}

func GetAppId(c *gin.Context) string {
	return c.GetHeader(headerKeyAppId)
}

func GetTimeStamp(c *gin.Context) string {
	return c.GetHeader(headerKeyTimeStamp)
}

func GetSign(c *gin.Context) string {
	return c.GetHeader(headerKeySign)
}

func GetPlatform(c *gin.Context) string {
	platformCode := c.GetHeader(headerKeyPlatform)
	return platformCode
}

func GetClientSource(c *gin.Context) string {
	h := c.GetHeader(headerKeyClientSource)
	if h == "" {
		return util.GetInterfaceToString(clientSource{
			AppId:     GetAppId(c),
			TimeStamp: GetTimeStamp(c),
			Sign:      GetSign(c),
			Platform:  GetPlatform(c),
		})
	}
	return h
}

type clientSource struct {
	AppId     string `json:"appId"`
	TimeStamp string `json:"timeStamp"`
	Sign      string `json:"sign"`
	Platform  string `json:"platform"`
}
